#############################################################
#
# GNU classpath for Sable VM
#
#############################################################

CLASSPATH_VER:=1.13.3
CLASSPATH_DIR:=$(BUILD_DIR)/sablevm-classpath-cdc-$(CLASSPATH_VER)
CLASSPATH_SOURCE:=sablevm-classpath-cdc-$(CLASSPATH_VER).tar.gz
CLASSPATH_CAT:=zcat
CLASSPATH_JAR_STAGING_PATH:=usr/share/sablevm-classpath/

$(DL_DIR)/$(CLASSPATH_SOURCE):
	cp /vndev/current/STB/TelseySDK/dl/$(CLASSPATH_SOURCE) $@

classpath-source: $(DL_DIR)/$(CLASSPATH_SOURCE)

$(CLASSPATH_DIR)/.unpacked: $(DL_DIR)/$(CLASSPATH_SOURCE)
	$(CLASSPATH_CAT) $(DL_DIR)/$(CLASSPATH_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $(CLASSPATH_DIR)/.unpacked

classpath-unpack: $(CLASSPATH_DIR)/.unpacked

$(CLASSPATH_DIR)/.configured: $(CLASSPATH_DIR)/.unpacked
	(cd $(CLASSPATH_DIR); rm -rf config.cache; \
		$(TARGET_CONFIGURE_OPTS) \
		LD=$(TARGET_CROSS)ld \
		CFLAGS="$(TARGET_CFLAGS)" \
		LDFLAGS="-L$(STAGING_DIR)/lib -L$(STAGING_DIR)/usr/lib" \
		./configure \
		--target=$(GNU_TARGET_NAME) \
		--host=$(GNU_TARGET_NAME) \
		--build=$(GNU_HOST_NAME) \
		--prefix=$(STAGING_DIR)/usr \
		--exec-prefix=$(STAGING_DIR)/usr \
		--bindir=$(STAGING_DIR)/usr/bin \
		--sbindir=$(STAGING_DIR)/usr/sbin \
		--libexecdir=$(STAGING_DIR)/usr/lib \
		--sysconfdir=$(STAGING_DIR)/etc \
		--datadir=$(STAGING_DIR)/usr/share \
		--localstatedir=$(STAGING_DIR)/var \
		--mandir=$(STAGING_DIR)/usr/man \
		--includedir=$(STAGING_DIR)/include \
		--infodir=$(STAGING_DIR)/usr/info \
		--disable-libtool \
		$(DISABLE_NLS) \
		$(DISABLE_LARGEFILE) \
		--with-jikes \
		--disable-alsa \
		--disable-gtk-peer \
	);
	touch $(CLASSPATH_DIR)/.configured

$(CLASSPATH_DIR)/.compiled: $(CLASSPATH_DIR)/.configured
	$(MAKE) -C $(CLASSPATH_DIR)
	touch $(CLASSPATH_DIR)/.compiled

$(STAGING_DIR)/$(CLASSPATH_JAR_STAGING_PATH)/libclasspath.jar: $(CLASSPATH_DIR)/.compiled
	$(MAKE) -C $(CLASSPATH_DIR) install

$(TARGET_DIR)/usr/lib/libclasspath.jar: $(STAGING_DIR)/$(CLASSPATH_JAR_STAGING_PATH)/libclasspath.jar
	mkdir -p $(TARGET_DIR)/usr/lib
	cp -dpf $(CLASSPATH_DIR)/lib/libclasspath.jar $(TARGET_DIR)/usr/lib/
	cp -dpf $(CLASSPATH_DIR)/native/jni/java-lang/.libs/libjava*.so \
		$(TARGET_DIR)/usr/lib/
	cp -dpf $(CLASSPATH_DIR)/native/jni/java-io/.libs/libjava*.so \
		$(TARGET_DIR)/usr/lib/
	cp -dpf $(CLASSPATH_DIR)/native/jni/java-nio/.libs/libjava*.so \
		$(TARGET_DIR)/usr/lib/
	cp -dpf $(CLASSPATH_DIR)/native/jni/java-util/.libs/libjava*.so \
		$(TARGET_DIR)/usr/lib/
	cp -dpf $(CLASSPATH_DIR)/native/jni/java-net/.libs/libjava*.so \
		$(TARGET_DIR)/usr/lib/
	-$(STRIP) --strip-unneeded $(TARGET_DIR)/usr/lib/libjava*.so

classpath: $(TARGET_DIR)/usr/lib/libclasspath.jar

classpath-clean:
	-$(MAKE) -C $(CLASSPATH_DIR) clean
	-rm -f $(TARGET_DIR)/usr/lib/libjava*.so*
	-rm -f $(CLASSPATH_DIR)/.configured $(CLASSPATH_DIR)/.compiled

classpath-dirclean:
	rm -rf $(CLASSPATH_DIR)

#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_CLASSPATH)),y)
TARGETS+=classpath
endif
