#############################################################
#
# mkcramfs for target.
# Relies on cramfs tools build for host.
#
#############################################################

MKCRAMFS_DIR := $(BUILD_DIR)/cramfs-1.1
MKCRAMFS_BINARY := mkcramfs
MKCRAMFS_SRC := mkcramfs.c
MKCRAMFS_TARGET_BINDIR := usr/bin

$(TARGET_DIR)/$(MKCRAMFS_TARGET_BINDIR)/$(MKCRAMFS_BINARY): \
		$(TARGET_DIR)/$(MKCRAMFS_TARGET_BINDIR) \
		$(MKCRAMFS_DIR)/$(MKCRAMFS_SRC)
	$(TARGET_CC) $(TARGET_CFLAGS) -o $@ $(MKCRAMFS_DIR)/$(MKCRAMFS_SRC) -lz
	chmod +x $@

$(TARGET_DIR)/$(MKCRAMFS_TARGET_BINDIR):
	mkdir -p $@

$(MKCRAMFS_DIR)/$(MKCRAMFS_SRC): $(MKCRAMFS_DIR)

mkcramfs: cramfs zlib $(TARGET_DIR)/$(MKCRAMFS_TARGET_BINDIR)/$(MKCRAMFS_BINARY)


#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_MKCRAMFS)),y)
TARGETS += mkcramfs
endif
