#ifndef _CP_COMMON_H
#define _CP_COMMON_H

/** @{ */
/**
 * @file
 * common symbols for cprops library -- mostly error codes
 */

#ifdef	__cplusplus
#ifndef __BEGIN_DECLS
#define __BEGIN_DECLS	extern "C" {
#endif
#ifndef __END_DECLS
#define __END_DECLS	}
#endif
#else
#ifndef __BEGIN_DECLS
#define __BEGIN_DECLS
#endif
#ifndef __END_DECLS
#define __END_DECLS
#endif
#endif

#if (defined linux || defined __linux || defined __gnu_linux__)

#ifndef _REENTRANT
#define _REENTRANT
#endif

/* for pthread_rwlock_t et al. */
#ifndef _XOPEN_SOURCE 
#define _XOPEN_SOURCE 600
#endif
#ifndef __USE_UNIX98
#define __USE_UNIX98
#endif

#include <features.h>

#endif

#define DEFAULT_LOGFILE                                    "cp.log"
#define DEFAULT_TIME_FORMAT                                "%Y-%m-%d %T"

        /* error codes */

#define CP_MEMORY_ALLOCATION_FAILURE                       10000
#define CP_INVALID_FUNCTION_POINTER                        10010
#define CP_THREAD_CREATION_FAILURE                         10020

#define CP_LOADLIB_FAILED                                  11010
#define CP_LOADFN_FAILED                                   11020
#define CP_MODULE_NOT_LOADED                               11030

#define CP_IO_ERROR                                        12000
#define CP_OPEN_PORT_FAILED                                12010
#define CP_HTTP_FETCH_FAILED                               12020
#define CP_INVALID_RESPONSE                                12030
#define CP_HTTP_EMPTY_REQUEST                              12100
#define CP_HTTP_INVALID_REQUEST_LINE                       12110
#define CP_HTTP_UNKNOWN_REQUEST_TYPE                       12120
#define CP_HTTP_INVALID_URI                                12130
#define CP_HTTP_VERSION_NOT_SPECIFIED                      12140
#define CP_HTTP_1_1_HOST_NOT_SPECIFIED                     12150
#define CP_HTTP_INCORRECT_REQUEST_BODY_LENGTH              12160
#define CP_SSL_CTX_INITIALIZATION_ERROR                    12200
#define CP_SSL_HANDSHAKE_FAILED                            12210

#define CP_LOG_FILE_OPEN_FAILURE                           13000
#define CP_LOG_NOT_OPEN                                    13010

#define CP_INVALID_VALUE                                   14000
#define CP_MISSING_PARAMETER                               14010
#define CP_BAD_PARAMETER_SET                               14020
#define CP_ITEM_EXISTS                               	   14030
#define CP_UNHANDLED_SIGNAL                                14040

#define CP_REGEX_COMPILATION_FAILURE                       15000

/** @} */

#endif

