#ifndef _CP_MTAB_H
#define _CP_MTAB_H

#include "common.h"

__BEGIN_DECLS

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

typedef struct _mtab_node
{
	unsigned char key;
	void *value;
	void *attr;
	struct _mtab_node *next;
} mtab_node;

mtab_node *mtab_node_new(unsigned char key, void *value, void *attr);

typedef void *(*mtab_dtr)(void *owner, mtab_node *node);

typedef struct _mtab
{
	int size;
	int items;
	mtab_node **table;
} mtab;

mtab *mtab_new(int size);
void mtab_delete(mtab *t);
void mtab_delete_custom(mtab *t, 
		                void *owner, 
						mtab_dtr dtr);
mtab_node *mtab_put(mtab *t, unsigned char key, void *value, void *attr);
inline mtab_node *mtab_get(mtab *t, unsigned char key);
void *mtab_remove(mtab *t, unsigned char key);

inline int mtab_count(mtab *t);

__END_DECLS

#endif
